package com.zhongshu.reward.server.core.timer;


import com.github.microservice.components.data.mongo.token.service.ResourceTokenService;
import com.zhongshu.reward.client.type.TransferStatus;
import com.zhongshu.reward.server.core.dao.WalletDao;
import com.zhongshu.reward.server.core.dao.WxTransferBatchDao;
import com.zhongshu.reward.server.core.domain.WxTransferBatch;
import com.zhongshu.reward.server.core.service.GoodsReceiptsService;
import com.zhongshu.reward.server.core.service.InviteReceiptsService;
import com.zhongshu.reward.server.core.service.WalletReceiptsService;
import com.zhongshu.reward.server.core.service.WxTransferService;
import com.zhongshu.reward.server.core.util.DateUtils;
import lombok.Cleanup;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.time.LocalDate;
import java.util.List;

/**
 * @author wjf
 * @date 2024/8/5
 */
@Component
@Log4j2
public class WalletTimer {

    @Autowired
    WalletDao walletDao;

    @Autowired
    WxTransferBatchDao wxTransferBatchDao;

    @Autowired
    WxTransferService wxTransferService;

    @Autowired
    WalletReceiptsService walletReceiptsService;

    @Autowired
    InviteReceiptsService inviteReceiptsService;

    @Autowired
    ResourceTokenService resourceTokenService;

    @Autowired
    GoodsReceiptsService goodsReceiptsService;


//    @Scheduled(fixedRate = 5000)
//    public void updateTransferStatus(){
//        try {
//            List<WxTransferBatch> byTransferStatus = wxTransferBatchDao.findByTransferStatus(TransferStatus.PROCESSING);
//            for (WxTransferBatch wxTransferBatch : byTransferStatus){
//                wxTransferService.updateTransferStatus(wxTransferBatch.getId());
//            }
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//    }

    /**
     * 定时结算邀请返利
     */
    @Scheduled(cron = "0 0 0/1 * * ? ")
    public void settle(){
        @Cleanup ResourceTokenService.Token token =  resourceTokenService.token("settleInviteReceipts");
        try {
            LocalDate now = LocalDate.now();
            log.info("-----------定时任务：开始结算邀请返利--------------");
            if (DateUtils.checkLastDayOfMonth() &&  now.getMonthValue() == 2){
                for (int i = now.getDayOfMonth(); i <= 31; i++) {
                    inviteReceiptsService.settle(i);
                }
            }
            inviteReceiptsService.settle(now.getDayOfMonth());
        }catch (Exception e){
            e.printStackTrace();
        }
    }

//    /**
//     * 定时结算商品返利
//     */
//    @Scheduled(fixedRate = 5*60*1000)
//    public void goodsSettle(){
//        @Cleanup ResourceTokenService.Token token =  resourceTokenService.token("settleGoodsReceipts");
//        try {
//            goodsReceiptsService.settle();
//        }catch (Exception e){
//            e.printStackTrace();
//        }
//    }

    /**
     * 定时生成持续返利订单
     */
    @Scheduled(cron = "0 0 0 6 * ?")
    public void autoReceipts(){
        @Cleanup ResourceTokenService.Token token =  resourceTokenService.token("autoInviteReceipts");
        try {
            inviteReceiptsService.autoReceipts();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
